#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/uio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <getopt.h>

#include "../packet.h"
#include "../htonl.h"

#define MAX_MESG_SIZE 2048
unsigned char mesg[MAX_MESG_SIZE];
PacketStruct *packet = (PacketStruct *)mesg;
CtlPacketStruct *control = (CtlPacketStruct *)mesg;

char *hostname = "207.22.48.181";

main(int argc, char **argv)
{
  int udp_socket;
  struct sockaddr_in serverName;
  struct sockaddr_in clientName;
  int client_length, size;
  unsigned char *uc;
  int i;
  int card;
  int o;
  long hostip;
  unsigned h1, h2, h3, h4;

  while ((o = getopt (argc, argv, "h:")) != -1)
    switch (o)
      {
      case 'h':
	hostname = optarg;
	break;
      }

  udp_socket = socket (PF_INET, SOCK_DGRAM, IPPROTO_UDP);
  if (udp_socket == -1)
    {
      perror("socket");
      exit(1);
    }

  memset(&serverName, 0, sizeof(serverName));
  memset(&clientName, 0, sizeof(clientName));

  serverName.sin_family = AF_INET;
  serverName.sin_addr.s_addr = htonl(INADDR_ANY);
  serverName.sin_port = htons(PM_CPORT);

  if (sscanf (hostname, "%u.%u.%u.%u", &h1, &h2, &h3, &h4) == 4)
    hostip = htonl ((h1<<24) | (h2<<16) | (h3<<8) | h4);
  else
    {
      struct hostent *he;
      he = gethostbyname (hostname);
      if (!he)
	{
	  fprintf (stderr, "Unknown host %s\n", hostname);
	  exit(1);
	}
      hostip = *(long *)he->h_addr_list[0];
    }

  printf("hostip %08x\n", hostip);
  clientName.sin_family = AF_INET;
  clientName.sin_addr.s_addr = hostip;
  clientName.sin_port = htons(PM_CPORT);

#if 0
  if (bind(udp_socket, (struct sockaddr *)&serverName, sizeof(serverName)) < 0)
    {
      perror("bind()");
      exit(1);
    }
#endif

  if (connect (udp_socket, (struct sockaddr *)&clientName, sizeof(clientName)) < 0)
    {
      perror("connect()");
      exit(1);
    }

  memcpy (control->magic, UDP_CONTROL_MAGIC, 8);
  control->command = CMD_ping;
  control->id = 0x12345678;

  size = send (udp_socket, control, sizeof (CtlPacketStruct), 0);
  if (size == -1)
    {
      perror("sendto()");
      exit(1);
    }


#if 0
  size = recvfrom(udp_socket, mesg,
		  MAX_MESG_SIZE, 0,
		  (struct sockaddr *) &clientName,
		  &client_length);
  if (size == -1)
    {
      perror("recvfrom()");
      exit(1);
    }
#endif

    /* never reached */
    return 0;
}
